/******************************************************************************/
/** @file    command.cpp
    @brief mrt plugin ̃vOCR}h̎

    @author mfsocket
    @date   2011/06/21
    @version 1.00
*/
/******************************************************************************/
#include "common.h"


/**
 * G[bZ[W01
 */
#define ERROR_STRING_ROUTER		"router ւ̃ANZXɎs܂B"
/**
 * G[bZ[W02
 */
#define ERROR_STRING_FIRMWARE	"t@[EFÃo[WmFĉB"


static char*	access_startup( PluginMethod* method, const char* url )
{
	char* p = method->access_get( url );
	if( p==NULL ){
		throw ERROR_STRING_ROUTER;
	}
	return p;
}

static int		_command_getlog( PluginMethod* method, const char* access_url )
{
	char* p = NULL;
	try{
		p = access_startup( method, access_url );

		p = method->filter_htmltag( method->filter_htmlclass( p, "log_area" ), "pre" );
		if( p==NULL ){
			throw ERROR_STRING_FIRMWARE;
		}
		p = method->string_trim( method->string_euc2sjis(p) );
	}catch( const char* e ){
		method->set_error( e );	// G[bZ[W̐ݒ
		return PLUGIN_ERROR;
	}
	method->out( p );
	return PLUGIN_SUCCESS;
}

/*----------------------------------------------------------------------------*/
//  command_unknown()
/*----------------------------------------------------------------------------*/
/**
  * @brief `ĂȂR}hBmethod->command() ŕR}h擾ł
  *
  * @param  method
  * @param  command
  * @param  command_arg
  *
  * @retval
  */
/*----------------------------------------------------------------------------*/
int		command_unknown( PluginMethod* method, int command, const char* command_arg )
{
	return PLUGIN_UNKNOWN;
}
/*----------------------------------------------------------------------------*/
//  command_reboot()
/*----------------------------------------------------------------------------*/
/**
  * @brief ċNR}h
  *
  * @param  method
  * @param  command
  * @param  command_arg
  *
  * @retval
  */
/*----------------------------------------------------------------------------*/
int		command_reboot( PluginMethod* method, int command, const char* command_arg )
{
	char* p = NULL;
	try{
		// reboot
		p = access_startup( method, "index.cgi/reboot_main" );

		p = method->filter_htmlid( p, "reboot_main" );

		char* hidden = method->pickup_htmlhidden( p );
		char* submit = method->pickup_htmlsubmit( p );

		p = method->access_post( "index.cgi/reboot_main_set", method->string_concat( hidden, submit ) );
		if( p==NULL ){
			throw ERROR_STRING_FIRMWARE;
		}
		method->out( "reboot now." );
		p = method->access_get( "index.cgi/reboot_main_finish" );
		if( p==NULL ){
			throw ERROR_STRING_FIRMWARE;
		}
		// ̃t@[EFAł͍ċN̎dɂ 50b or 60b ̂ǂ炩Bl擾邱Ƃ\Aߑł
		method->out( "please wait 50 second..." );
		try{
			method->sleep(50000);
		}catch( const SigintException&  ){
			method->out( "signal end. please check router's log." );
			return PLUGIN_SIGNAL;
		}
		method->out( "reboot end." );
	}catch( const char* e ){
		method->set_error( e );	// G[bZ[W̐ݒ
		return PLUGIN_ERROR;
	}
	return PLUGIN_SUCCESS;
}
/*----------------------------------------------------------------------------*/
//  command_linkup()
/*----------------------------------------------------------------------------*/
/**
  * @brief ڑR}h
  *
  * @param  method
  * @param  command
  * @param  command_arg
  *
  * @retval
  */
/*----------------------------------------------------------------------------*/
int		command_linkup( PluginMethod* method, int command, const char* command_arg )
{
	return PLUGIN_UNKNOWN;
}
/*----------------------------------------------------------------------------*/
//  command_linkdown()
/*----------------------------------------------------------------------------*/
/**
  * @brief ؒfR}h
  *
  * @param  method
  * @param  command
  * @param  command_arg
  *
  * @retval
  */
/*----------------------------------------------------------------------------*/
int		command_linkdown( PluginMethod* method, int command, const char* command_arg )
{
	return PLUGIN_UNKNOWN;
}
/*----------------------------------------------------------------------------*/
//  command_getlog()
/*----------------------------------------------------------------------------*/
/**
  * @brief O擾R}h
  *
  * @param  method
  * @param  command
  * @param  command_arg
  *
  * @retval
  */
/*----------------------------------------------------------------------------*/
int		command_getlog( PluginMethod* method, int command, const char* command_arg )
{
	return _command_getlog( method, "index.cgi/log_main" );
}
/*----------------------------------------------------------------------------*/
//  command_getsyslog()
/*----------------------------------------------------------------------------*/
/**
  * @brief VXeO擾R}h
  *
  * @param  method
  * @param  command
  * @param  command_arg
  *
  * @retval
  */
/*----------------------------------------------------------------------------*/
int		command_getsyslog( PluginMethod* method, int command, const char* command_arg )
{
	return _command_getlog( method, "index.cgi/log_main_show?LOG_SAVE_SELECT=1" );
}
/*----------------------------------------------------------------------------*/
//  command_getip()
/*----------------------------------------------------------------------------*/
/**
  * @brief WANIP̎擾R}h
  *
  * @param  method
  * @param  command
  * @param  command_arg
  *
  * @retval
  */
/*----------------------------------------------------------------------------*/
int		command_getip(  PluginMethod* method, int command, const char* command_arg )
{
	char* p = NULL;
	try{
		p = access_startup( method, "index.cgi/info_main" );

		p = strstr( p, "'>WAN" );
		if( p==NULL ){
			throw ERROR_STRING_FIRMWARE;
		}
		p = method->filter_htmlclass( p, "small_item_td2" );
		if( p==NULL ){
			throw ERROR_STRING_FIRMWARE;
		}
	}catch( const char* e ){
		method->set_error( e );	// G[bZ[W̐ݒ
		return PLUGIN_ERROR;
	}
	method->outf( "WAN IP: %s\n", method->string_trim(p) );
	return PLUGIN_SUCCESS;
}
/*----------------------------------------------------------------------------*/
//  command_getips()
/*----------------------------------------------------------------------------*/
/**
  * @brief WAN̑SĂ IP AhX̎擾R}h
  *
  * @param  method
  * @param  command
  * @param  command_arg
  *
  * @retval
  */
/*----------------------------------------------------------------------------*/
int		command_getips( PluginMethod* method, int command, const char* command_arg )
{
	return PLUGIN_UNKNOWN;
}
/*----------------------------------------------------------------------------*/
//  command_getall()
/*----------------------------------------------------------------------------*/
/**
  * @brief@WAN̑SĂ̐ڑ擾R}h
  *
  * @param  method
  * @param  command
  * @param  command_arg
  *
  * @retval
  */
/*----------------------------------------------------------------------------*/
int		command_getall( PluginMethod* method, int command, const char* command_arg )
{
	return PLUGIN_UNKNOWN;
}
/*----------------------------------------------------------------------------*/
//  command_enable_eco()
/*----------------------------------------------------------------------------*/
/**
  * @brief GR[h̗LBLɂ邾Ȃ̂ŊJn͍̐sȂ
  *
  * @param  method
  * @param  command
  * @param  command_arg
  *
  * @retval
  */
/*----------------------------------------------------------------------------*/
int		command_enable_eco( PluginMethod* method, int command, const char* command_arg )
{
	char* p = NULL;
	try{
		p = access_startup( method, "index.cgi/eco_main" );

		p = method->filter_htmlid( p, "eco_main" );
		if( p==NULL ){
			throw ERROR_STRING_FIRMWARE;
		}
			
		char* input_select = method->pickup_htmlinputselect( p, true );
		char* submit       = method->pickup_htmlsubmit( p );

		input_select = method->string_setvalue( input_select, "ECO_FUNC_STEP3", "normal" );
		p = method->string_concat(input_select, submit);
		p = method->access_post( "index.cgi/eco_main_set", p );
		if( p==NULL ){
			throw ERROR_STRING_FIRMWARE;
		}

		// Ԃ̎擾/xĔf̂ POST  GET 擾
		p = method->access_get( "index.cgi/eco_main" );
		if( p==NULL ){
			throw ERROR_STRING_FIRMWARE;
		}
		// Ώ classid 擾
		p = method->filter_htmlclass( p, "small_item_td2" );
		if( p==NULL ){
			throw ERROR_STRING_FIRMWARE;
		}
	}catch( const char* e ){
		method->set_error( e );	// G[bZ[W̐ݒ
		return PLUGIN_ERROR;
	}
	method->outf( "u%svɐ؂ւ܂B\n", method->string_euc2sjis( p ) );
	return PLUGIN_SUCCESS;
}
/*----------------------------------------------------------------------------*/
//  command_start_eco()
/*----------------------------------------------------------------------------*/
/**
  * @brief GR[hJnBw肵Ȃꍇ͍JnAI͖B
  *
  * @param  method
  * @param  command
  * @param  command_arg  start=[hhmm]: Jn   end:[hhmm]: I
  *
  * @retval
  */
/*----------------------------------------------------------------------------*/
int		command_start_eco(  PluginMethod* method, int command, const char* command_arg )
{
	char* p = NULL;
	try{
		p = access_startup( method, "index.cgi/eco_main" );

		p = method->filter_htmlid( p, "eco_main" );
		if( p==NULL ){
			throw ERROR_STRING_FIRMWARE;
		}

		// R}h̉
		char* start_h = NULL;
		char* start_m = NULL;
		char* end_h   = NULL;
		char* end_m   = NULL;
		char* eco_type= "normal";
		if( command_arg != NULL ){
			// /o "end=1800&start=1500"
			char work[12];

			char* start = method->string_getvalue( command_arg, "start" );
			char* end   = method->string_getvalue( command_arg, "end" );
			if( start ){
				::sprintf_s( work, _countof(work),  "%02d", atoi(start) );
				if( strlen(start)<=2 ){
					start_h = method->string_substr( work, 2, (int)strlen(work) );
				}else{
					start_h = method->string_substr( work, 0, 2 );
					start_m = method->string_substr( work, 2, (int)strlen(work) );
				}
				if( start_m==NULL )start_m = "00";
			}
			if( end ){
				::sprintf_s( work, _countof(work),  "%02d", atoi(end) );
				if( strlen(end)<=2 ){
					end_h = method->string_substr( work, 2, (int)strlen(work) );
				}else{
					end_h = method->string_substr( work, 0, 2 );
					end_m = method->string_substr( work, 2, (int)strlen(work) );
				}
				if( end_m==NULL )end_m = "00";
			}

			char* work_eco_type =  method->string_getvalue( command_arg, "type" );
			if( work_eco_type  ){
				if( strcmp( work_eco_type, "normal" )==0 || strcmp( work_eco_type, "usb" )==0 || strcmp( work_eco_type, "game" )==0 ){
					eco_type = work_eco_type;
				}
			}
		}

			
		char* input_select = method->pickup_htmlinputselect( p, false );
		char* submit       = method->pickup_htmlsubmit( p );
		input_select = method->string_setvalue( input_select, "ECO_FUNC_STEP3", "normal" );
		input_select = method->string_setvalue( input_select, "ECO_MODE_SELECT", eco_type );
		


		// ݎ̎擾( xXg̓[^[̎擾鎖 )
		SYSTEMTIME st;
		::GetLocalTime( &st );
		int h;
		char start_hour[12], start_min[12];
		char end_hour[12], end_min[12];

		// ftHg̊Jn/I̐
		st.wMinute = (st.wMinute + 1) % 60;
		if( st.wMinute==0 ){
			st.wHour = (st.wHour+1) % 24;
		}
		h = (st.wHour-1);
		if( h<0 )h = 23;

		// R}hCIvV̔
		if( start_h == NULL ){
			::sprintf_s( start_hour, _countof(start_hour), "%02d", st.wHour );
			::sprintf_s( start_min,  _countof(start_min),  "%02d", st.wMinute );
		}else{
			::strcpy_s( start_hour, _countof(start_hour), start_h );
			::strcpy_s( start_min,  _countof(start_min), start_m );
		}
		if( end_h == NULL ){
			::sprintf_s( end_hour,   _countof(end_hour),   "%02d", h );
			::sprintf_s( end_min,    _countof(end_min),    "%02d", st.wMinute );
		}else{
			::strcpy_s( end_hour, _countof(end_hour), end_h );
			::strcpy_s( end_min,  _countof(end_min), end_m );
		}
		// ݒ
		input_select = method->string_setvalue( input_select, "ECO_START_HH", start_hour );
		input_select = method->string_setvalue( input_select, "ECO_START_MM", start_min );
		input_select = method->string_setvalue( input_select, "ECO_END_HH", end_hour );
		input_select = method->string_setvalue( input_select, "ECO_END_MM", end_min );
		
		// Mf[^̐
		char* post_data = method->string_concat(input_select, submit);

		// M
		p = method->access_post( "index.cgi/eco_main_set", post_data );
		if( p==NULL ){
			throw ERROR_STRING_FIRMWARE;
		}

		// ő 1ԑ҂
		if( start_h==NULL ){
			int count = 0;
			method->out( "please wait 1 minute..." );
			while( true ){
				if( count++ > 12 ){
					method->set_error( "Ԃ̕ω߁Af܂B" );
					throw PLUGIN_ERROR;
				}


				p = method->access_get( "index.cgi/eco_main" );
				if( p==NULL ){
					throw ERROR_STRING_FIRMWARE;
				}
				p = method->filter_htmlclass( p, "small_item_td2" );
				if( p==NULL ){
					throw ERROR_STRING_FIRMWARE;
				}

				p = method->string_euc2sjis( p );
				if( strstr( p, "N" )!=NULL ){
					method->outf( "u%svɐ؂ւ܂B\n", p );

					// I`ȂꍇAiɃGR[h
					if( end_h == NULL ){
						// ^C}[N OFF 
						post_data = method->string_deletekey( post_data, "TIMER" );
						p = method->access_post( "index.cgi/eco_main_set", post_data );
					}
					break;
				}
				method->sleep(5000);
			}
		}else{
			method->out( "w莞œo^܂B" );
		}
				
	}catch( const char* e ){
		method->set_error( e );	// G[bZ[W̐ݒ
		return PLUGIN_ERROR;
	}
	return PLUGIN_SUCCESS;
}
/*----------------------------------------------------------------------------*/
//  command_disable_eco()
/*----------------------------------------------------------------------------*/
/**
  * @brief GR[h𖳌
  *
  * @param  method
  * @param  command
  * @param  command_arg
  *
  * @retval
  */
/*----------------------------------------------------------------------------*/
int		command_disable_eco( PluginMethod* method, int command, const char* command_arg )
{
	char* p = NULL;
	try{
		p = access_startup( method, "index.cgi/eco_main" );

		p = method->access_post( "index.cgi/eco_main_set", "ECO_FUNC_STEP3=disable&DISABLED_CHECKBOX=TIMER&CHECK_ACTION_MODE=0" );
		if( p==NULL ){
			throw ERROR_STRING_FIRMWARE;
		}
		// Ԃ̎擾/xĔf̂ POST  GET 擾
		p = method->access_get( "index.cgi/eco_main" );
		if( p==NULL ){
			throw ERROR_STRING_FIRMWARE;
		}
		// Ώ classid 擾
		p = method->filter_htmlclass( p, "small_item_td2" );
		if( p==NULL ){
			throw ERROR_STRING_FIRMWARE;
		}
	}catch( const char* e ){
		method->set_error( e );	// G[bZ[W̐ݒ
		return PLUGIN_ERROR;
	}
	method->outf( "u%svɐ؂ւ܂B\n", method->string_euc2sjis( p ) );
	return PLUGIN_SUCCESS;
}
/*----------------------------------------------------------------------------*/
//  command_eco()
/*----------------------------------------------------------------------------*/
/**
  * @brief GR[h̏ڍאR}h
  *
  * @param  method
  * @param  command
  * @param  command_arg
  *
  * @retval
  */
/*----------------------------------------------------------------------------*/
int		command_eco( PluginMethod* method, int command, const char* command_arg )
{
	return PLUGIN_UNKNOWN;
}
